package me.totalfreedom.totalfreedommod.rank;

import me.totalfreedom.totalfreedommod.TotalFreedomMod;
import net.luckperms.api.model.user.User;
import net.md_5.bungee.api.ChatColor;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.UUID;

@FunctionalInterface
public interface GroupProvider<T extends DisplayableGroup>
{
    GroupProvider<DisplayableGroup> NON_OP = () -> new DisplayableGroup("non_op", "Non-Ops", "", ChatColor.WHITE, null, false, false);
    GroupProvider<DisplayableGroup> OP = () -> new DisplayableGroup("op", "Operators", "Op", ChatColor.GREEN, null, false, false);
    GroupProvider<DisplayableGroup> ADMIN = () -> new DisplayableGroup("admin", "Administrators", "Admin", ChatColor.DARK_GREEN, org.bukkit.ChatColor.DARK_GREEN, true, true);
    GroupProvider<DisplayableGroup> SENIOR_ADMIN = () -> new DisplayableGroup("senior", "Senior Administrators", "SrA", ChatColor.GOLD, org.bukkit.ChatColor.GOLD, true, true);

    static User getUser(Player player)
    {
        return TotalFreedomMod.getPlugin()
                .lpb.getAPI()
                .getPlayerAdapter(Player.class)
                .getUser(player);
    }

    T getGroup();

    static GroupProvider<DisplayableGroup> fromArgument(String arg) {
        return switch (arg.toLowerCase())
                {
                    case "op" -> OP;
                    case "admin" -> ADMIN;
                    case "senior" -> SENIOR_ADMIN;
                    default -> NON_OP;
                };
    }
}